package org.netkernel.layer0.boot;

import java.net.URI;

public class ModuleSourceWithLevel
{	private URI mModuleSource;
	private Integer mLevel;
	private String mDeclaration;

	public ModuleSourceWithLevel(URI aSource, int aLevel, String aDeclaration) throws IllegalArgumentException
	{	mModuleSource=aSource;
		if(aLevel>=0)
		{	mLevel=aLevel;
		}
		else throw new IllegalArgumentException("Level must be a positive integer");
		mDeclaration=aDeclaration;
	}
	
	public URI getSource()
	{	return mModuleSource;
	}
	
	public int getLevel()
	{	return mLevel;
	}
	
	public String getDeclaration()
	{	return mDeclaration;
	}
	
	@Override
	public boolean equals(Object obj)
	{	return this.hashCode()==obj.hashCode();			
	}

	@Override
	public int hashCode()
	{	return mModuleSource.hashCode()|mLevel.hashCode();
	}
	
}