package org.netkernel.layer0.meta.impl;

import org.netkernel.layer0.meta.ILogicalEndpoints;
import org.netkernel.layer0.util.PairList;
import org.netkernel.urii.IIdentifier;
import org.netkernel.urii.ISpace;


public class EndpointPartsImpl implements ILogicalEndpoints
{
	private final PairList mParts;
	
	public static final EndpointPartsImpl EMPTY = new EndpointPartsImpl(PairList.EMPTY);
	
	public EndpointPartsImpl(PairList aParts)
	{	mParts=aParts;
	}
	
	public IIdentifier getIdentifier(int aIndex)
	{	return (IIdentifier)mParts.getValue1(aIndex);
	}

	public boolean isDelegated(int aIndex)
	{	return mParts.getValue2(aIndex)!=null;
	}

	public ISpace getDelegatedSpace(int aIndex)
	{	return (ISpace)mParts.getValue2(aIndex);
	}

	public int size()
	{	return mParts.size();
	}

}