package org.netkernel.layer0.meta.impl;

import org.netkernel.layer0.meta.ISpaceElements;
import org.netkernel.layer0.util.TupleList;
import org.netkernel.urii.IEndpoint;
import org.netkernel.urii.IIdentifier;
import org.netkernel.urii.ISpace;


public class SpaceElementsImpl implements ISpaceElements
{
	private final TupleList mParts;
	
	public static final ISpaceElements EMPTY = new SpaceElementsImpl(new TupleList(3,0));
	
	/** Construct with a tuple list {IIdentifier aIndentifier, ISpace aDelegatedSpace, IEndpoint aPhysicalEndpoint}
	 * @param aParts
	 */
	public SpaceElementsImpl(TupleList aParts)
	{	if (aParts.getTupleLength()==3)
		{	mParts=aParts;
		}
		else
		{	throw new IllegalArgumentException();
		}
	}
	
	public IIdentifier getIdentifier(int aIndex)
	{	return (IIdentifier)mParts.getValue(aIndex,0);
	}

	public boolean isDelegated(int aIndex)
	{	return mParts.getValue(aIndex,1)!=null;
	}

	public ISpace getDelegatedSpace(int aIndex)
	{	return (ISpace)mParts.getValue(aIndex,1);
	}

	public int size()
	{	return mParts.size();
	}

	public IEndpoint getPhysicalEndpoint(int aIndex)
	{	return (IEndpoint)mParts.getValue(aIndex, 2);
	}

}
